#!/usr/bin/python
import numpy as np
import matplotlib.pyplot as plt
import math

def iperorizax(t):
	return beta*np.cosh(t)+xcon

def iperorizay(t):
	return alfa*np.sinh(t)+ycon
  
def iperoriza1x(t):
	return -beta*np.cosh(t)+xcon

def iperoriza1y(t):
	return alfa*np.sinh(t)+ycon
  
def iperoriznegx(t):
	return beta*np.sinh(t)+xcon
   
def iperoriznegy(t):
	return alfa*np.cosh(t)+ycon

def iperorizneg1x(t):
	return beta*np.sinh(t)+xcon

def iperorizneg1y(t):
	return -np.cosh(t)*alfa+ycon

def iperposx(t):
	return  -beta*sinfi*np.cosh(t)+alfa*cosfi*np.sinh(t)+xcon

def iperposy(t):
	return  beta*cosfi*np.cosh(t)+alfa*sinfi*np.sinh(t)+ycon

def iperpos1x(t):
	return  beta*sinfi*np.cosh(t)+alfa*cosfi*np.sinh(t)+xcon

def iperpos1y(t):
	return -beta*cosfi*np.cosh(t)+alfa*sinfi*np.sinh(t)+ycon

def ipernegx(t):
	return alfa*cosfi*np.cosh(t)-beta*sinfi*np.sinh(t)+xcon

def ipernegy(t):
	return alfa*sinfi*np.cosh(t)+beta*cosfi*np.sinh(t)+ycon

def  iperneg1x(t):
	return -alfa*cosfi*np.cosh(t)-beta*sinfi*np.sinh(t)+xcon

def iperneg1y(t):
	return -alfa*sinfi*np.cosh(t)+beta*cosfi*np.sinh(t)+ycon

def parabola1x(t):
	return cosalfa*abs(mi1+mi2)/2*np.sqrt(-(mi1+mi2)/deta)*np.power(t,2)-sinalfa*t+xv

def parabola1y(t):
	return sinalfa*abs(mi1+mi2)/2*np.sqrt(-(mi1+mi2)/deta)*np.power(t,2)+cosalfa*t+yv

def parabola2x(t):
	return -cosalfa*abs(mi1+mi2)/2*np.sqrt(-(mi1+mi2)/deta)*np.power(t,2)-sinalfa*t+xv

def parabola2y(t):
	return -sinalfa*abs(mi1+mi2)/2*np.sqrt(-(mi1+mi2)/deta)*np.power(t,2)+cosalfa*t+yv

def ellisseorix(t):
	return  np.sqrt(abs(f/a))*np.cos(t)+xcon

def ellisseoriy(t):
	return np.sqrt(abs(f/b))*np.sin(t)+ycon

def ellissegenx(t):
	return  alfa*cosfi*np.cos(t)-beta*sinfi*np.sin(t)+xcon

def ellissegeny(t):
	return alfa*sinfi*np.cos(t)+beta*cosfi*np.sin(t)+ycon

def  paraverty(t):
	return -(a*np.power(t,2)+d*t+f)/e


print 'Equazione a x^2+b y^2+ c xy + d x +e y + f = 0'
a = float(input('inserisci a:'))
b = float(input('inserisci b:'))
c = float(input('inserisci c:'))
d = float(input('inserisci d:'))
e = float(input('inserisci e:'))
f = float(input('inserisci f:'))
deta=a*(b*f-e*e/4)-(b*d*d+c*(c*f-d*e))/4
deta1=a*b-c*c/4;
if (deta==0):
	print 'WWWARNING!!!! CONICA RIDUCIBILE..NON LA DISEGNAMO'
else:
	if (deta1<0):
		if (c==0):
			mi1=math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2)-4*deta1)/2+a/2+b/2
			mi2=-math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
  			alfa=math.sqrt(abs(deta/(mi1*deta1)))
  			beta=math.sqrt(abs(deta/(mi2*deta1)))
			xcon=(c*e-2*b*d)/(4*deta1)
			ycon=(c*d-2*a*e)/(4*deta1)
			t1=np.arange(-20,20,1)
			coorx=-beta*t1+xcon
			coory=alfa*t1+ycon
			coory1=-alfa*t1+ycon
			plt.plot(coorx,coory)
			plt.plot(coorx,coory1)
			if ((mi1*deta/deta1)>0):
				t1=np.arange(-3.14,3.14,0.007)
				plt.plot(iperorizax(t1),iperorizay(t1))
				plt.plot(iperoriza1x(t1),iperoriza1y(t1))
				plt.show()
			else:
				t1=np.arange(-3.14,3.14,0.007)
				plt.plot(iperoriznegx(t1),iperoriznegy(t1))
				plt.plot(iperorizneg1x(t1),iperorizneg1y(t1))
				plt.show()
		else:
			mi1=math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
  			mi2=-math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
  			k=2*(mi1-a)/c
 			xcon=(c*e-2*d*b)/(4*deta1)
 			ycon=(c*d-2*a*e)/(4*deta1)
 			cosfi=1/math.sqrt(1+math.pow(k,2))
 			sinfi=k/math.sqrt(1+math.pow(k,2))
 			alfa=math.sqrt(abs(deta/(mi1*deta1)))
			beta=math.sqrt(abs(deta/(mi2*deta1)))
			t1=np.arange(-20,20,1)
			coorx=alfa*cosfi*t1-beta*sinfi*t1+xcon
			coory=alfa*sinfi*t1+beta*cosfi*t1+ycon
			plt.plot(coorx,coory)
			coorx=-alfa*cosfi*t1-beta*sinfi*t1+xcon
			coory=-alfa*sinfi*t1+beta*cosfi*t1+ycon
			plt.plot(coorx,coory)
			if ((mi1*deta/deta1)>0):
				t1=np.arange(-3.14,3.14,0.007)
				plt.plot(iperposx(t1),iperposy(t1))
				plt.plot(iperpos1x(t1),iperpos1y(t1))
				plt.show()
			else:
				t1=np.arange(-3.14,3.14,0.007)
				plt.plot(ipernegx(t1),ipernegy(t1))
				plt.plot(iperneg1x(t1),iperneg1y(t1))
				plt.show()
	else:
		if (deta1==0):
			if (b==0)and(c==0):
				coorx=-d/(2*a)
				plt.axvline(x=coorx)
				t1=np.arange(-20,20,0.007)
				plt.plot(t1,paraverty(t1))
				plt.show()
			else:
				mi1=math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
				mi2=-math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
				val=-(16*math.pow(b,2)*math.pow(b,2)*f-4*math.pow(b,2)*b*math.pow(e,2)+8*math.pow(b,2)*math.pow(c,2)*f)
				val=val-(b*math.pow(c,2)*(math.pow(d,2)-2*math.pow(e,2))+math.pow(c,2)*c*(c*f-d*e))
				val=val/(math.pow((4*math.pow(b,2)+math.pow(c,2)),2)*(2*b*d-c*e))
				xv=2*b*val
				yv=-c*val-(2*b*e+c*d)/(4*math.pow(b,2)+math.pow(c,2))
				ca=-c/(2*b)
				cosalfa=1/math.sqrt(math.pow(ca,2) +1)
				sinalfa=(ca)/math.sqrt(math.pow(ca,2) +1)
				delta=-4*a*b*math.pow(c,2)*(16*math.pow(b,2)*math.pow(b,2)*math.pow((xv+1),2)-16*math.pow(b,2)*b*c*yv*(xv+1))
				delta=delta-4*a*b*math.pow(c,2)*(4*math.pow(b,2)*c*(c*(2*xv+math.pow(yv,2)+2)-2*e*(xv+1)))
				delta=delta-4*a*b*math.pow(c,2)*(-4*b*math.pow(c,2)*(c*yv-(e*yv+f))+math.pow(c,2)*c*(c-2*e))
				delta=delta-64*math.pow(b,2)*math.pow(b,2)*b*math.pow(c,2)*(d*(xv+1)+f)
				delta=delta+16*math.pow(b,2)*math.pow(b,2)*math.pow(c,2)*(math.pow(c,2)*(math.pow(xv,2)+2*xv+1))
				delta=delta+16*math.pow(b,2)*math.pow(b,2)*math.pow(c,2)*(2*c*(d*yv+e*(xv+1))+math.pow(e,2))
				delta=delta-16*math.pow(b,2)*b*math.pow(c,2)*c*(math.pow(c,2)*yv*(xv+1)+c*(d*(xv+2)+e*yv+2*f)-d*e)
				delta=delta+4*math.pow(b,2)*math.pow(c,2)*math.pow(c,2)*(math.pow(c,2)*(2*xv+math.pow(yv,2)+2)+2*c*(d*yv+e)+math.pow(d,2))
				delta=delta-4*b*math.pow(c,2)*math.pow(c,2)*math.pow(c,2)*(c*yv+d)
				delta=delta+math.pow(c,2)*math.pow(c,2)*math.pow(c,2)*math.pow(c,2)
				t1=np.arange(-20,20,1)
				coorx=cosalfa*t1
				coory=sinalfa*t1-(2*b*e+c*d)/(4*math.pow(b,2)+math.pow(c,2))
				plt.plot(coorx,coory)
				if (delta>0):
					t1=np.arange(-20,20,0.007)
					plt.plot(parabola1x(t1),parabola1y(t1))
					plt.show()
				else:
					t1=np.arange(-20,20,0.007)
					plt.plot(parabola2x(t1),parabola2y(t1))
					plt.show()		        
		else:
			if ((a+b*deta)>0):
				print 'WARRRNING!!!! ELLISSE A PUNTI COMPLESSI'
			else:
				if (c==0):
					mi1=math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
					xcon=(c*e-2*d*b)/(4*deta1)
					ycon=(c*d-2*a*e)/(4*deta1)
					coorx=xcon
					coory=ycon
					t1=np.arange(-20,20,1)
 					plt.axvline(x=coorx)
					plt.axhline(y=coory)
					t1=np.arange(-3.14,3.14,0.007)
					plt.plot(ellisseorix(t1),ellisseoriy(t1))
					plt.show()
				else:
					mi1=math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
					mi2=-math.sqrt(math.pow(a,2)+2*a*b+math.pow(b,2) -4*deta1)/2+a/2+b/2
  					k=2*(mi1-a)/c
  					xcon=(c*e-2*d*b)/(4*deta1)
 					ycon=(c*d-2*a*e)/(4*deta1)
 					cosfi=1/math.sqrt(1+math.pow(k,2))
 					sinfi=k/math.sqrt(1+math.pow(k,2))
 					alfa=math.sqrt(abs(deta/(mi1*deta1)))
					beta=math.sqrt(abs(deta/(mi2*deta1)))
					t1=np.arange(-20,20,1)
   					plt.plot(cosfi*t1+xcon,sinfi*t1+ycon)
					plt.plot(-sinfi*t1+xcon,cosfi*t1+ycon)
					t1=np.arange(-3.14,3.14,0.007)
					plt.plot(ellissegenx(t1),ellissegeny(t1))
					plt.show()
	
